#!/usr/bin/env python2
# coding: utf-8
import subprocess
import os
import commands
import locale
import xdg.DesktopEntry
from gi.repository import Gio,GLib

def add_to_panel(desktop_path):
    i = 0
    panel_schema = Gio.Settings.new("org.mate.panel")
    applet_list = panel_schema.get_strv("object-id-list")

    while (i < len(applet_list)):
        test_obj = "object_%d" % (i)
        if test_obj in applet_list:
            path = "/org/mate/panel/objects/%s/" % (test_obj)
            new_schema = Gio.Settings.new_with_path("org.mate.panel.object", path)
            if (new_schema.get_string("launcher-location") == desktop_path):
                return
        i += 1

    i = 0
    while True:
        test_obj = "object_%d" % (i)
        if test_obj in applet_list:
            i += 1
        else:
            break
    
    path = "/org/mate/panel/objects/%s/" % (test_obj)
    new_schema = Gio.Settings.new_with_path("org.mate.panel.object", path)
    new_schema.set_string("launcher-location", desktop_path)
    new_schema.set_string("object-type", "launcher")
    new_schema.set_string("toplevel-id", "bottom")
    new_schema.set_int("position", 50)
    applet_list.append(test_obj)
    panel_schema.set_strv("object-id-list", applet_list)

def delete_from_panel(desktop_path):
    i=0
    panel_schema = Gio.Settings.new("org.mate.panel")
    applet_list = panel_schema.get_strv("object-id-list")
    while (i < len(applet_list)):
        test_obj = "object_%d" % (i)
        if test_obj in applet_list:
            path = "/org/mate/panel/objects/%s/" % (test_obj)
            new_schema = Gio.Settings.new_with_path("org.mate.panel.object", path)
            if (new_schema.get_string("launcher-location") == desktop_path):
                applet_list.remove(test_obj)
                panel_schema.set_strv("object-id-list", applet_list)
        i += 1

def add_normal_object_to_panel(desktop_name):
    panel_schema = Gio.Settings.new("org.mate.panel")
    applet_list = panel_schema.get_strv("object-id-list")

    if desktop_name == "firefox.desktop":
        path = "/org/mate/panel/objects/browser/"
    if desktop_name == "caja-browser.desktop":
        path = "/org/mate/panel/objects/home/"
    new_schema = Gio.Settings.new_with_path("org.mate.panel.object", path)

    if desktop_name == "firefox.desktop":
        if "browser" in applet_list:
            if new_schema.get_string("toplevel-id") == None:
                panel_schema.set_strv("object-id-list", applet_list)
                return
    if desktop_name == "caja-browser.desktop":
        if "home" in applet_list:
            if new_schema.get_string("toplevel-id") != None:
                panel_schema.set_strv("object-id-list", applet_list)
                return
    
    if desktop_name == "firefox.desktop":
        new_schema.set_string("launcher-location", "firefox.desktop")
        new_schema.set_int("position", 52)
        new_schema.set_string("object-type", "launcher")
        new_schema.set_string("toplevel-id", "bottom")
        if "browser" not in applet_list:
            applet_list.append("browser")
    if desktop_name == "caja-browser.desktop":
        new_schema.set_string("launcher-location", "caja-home.desktop")
        new_schema.set_int("position", 51)
        new_schema.set_string("object-type", "launcher")
        new_schema.set_string("toplevel-id", "bottom")
        if "home" not in applet_list:
            applet_list.append("home")
                
    panel_schema.set_strv("object-id-list", applet_list)
    
def delete_normal_object_from_panel(desktop_name):
    panel_schema = Gio.Settings.new("org.mate.panel")
    applet_list = panel_schema.get_strv("object-id-list")
    
    if desktop_name == "firefox.desktop":
        applet_list.remove("browser")
    if desktop_name == "caja-browser.desktop":
        applet_list.remove("home")
                
    panel_schema.set_strv("object-id-list", applet_list)

def directory_changed(monitor, file1, file2, evt_type):
    if not file1.get_path().endswith(".desktop"):
        return;
    desktopfile=file1.get_path()
    
    desktopItem = xdg.DesktopEntry.DesktopEntry(file1.get_basename())
    if (desktopItem.getNoDisplay()):
        return;
    else:
        if  os.path.exists(desktopfile):
            t = commands.getoutput('cat '+desktopfile+' |grep NoDisplay').strip()
            if 'true' in t:
                return;
    if (desktopItem.getOnlyShowIn() != [u'MATE'] and len(desktopItem.getOnlyShowIn()) != 0):
        return 
    else:
        if  os.path.exists(desktopfile):
            t = commands.getoutput('cat '+desktopfile+' |grep OnlyShowIn').strip()
            if t != "":
                if not 'MATE' in t:
                    return;
    dekstopdir = GLib.get_user_special_dir(GLib.USER_DIRECTORY_DESKTOP)

#    if evt_type == Gio.FileMonitorEvent.CHANGED:
#        print"change"
#    if evt_type == Gio.FileMonitorEvent.ATTRIBUTE_CHANGED:
#        print"change attr"
#    if evt_type == Gio.FileMonitorEvent.MOVED_IN:
#        print"move in"
    if evt_type == Gio.FileMonitorEvent.CREATED:
        #print "create"
        if file1 != None:
            if file1.get_basename() in curstate:
                #print("在列表里")
                return;
            curstate.append(file1.get_basename())
#            if file1.get_basename() == "firefox.desktop" or file1.get_basename() == "caja-browser.desktop":
#                add_normal_object_to_panel(file1.get_basename())
#                 return;
#            else:
#                add_to_panel(file1.get_path())
#            status = subprocess.call('cp '+file1.get_path() + ' ' + dekstopdir,shell=True)
#            os.system("chmod +x "+dekstopdir +"/"+ file1.get_basename())
    if evt_type == Gio.FileMonitorEvent.DELETED:
        #print "delete"
        if file1 != None:
            if file1.get_basename() not in curstate:
                return;
            curstate.remove(file1.get_basename())
            if file1.get_basename() == "firefox.desktop" or file1.get_basename() == "caja-browser.desktop":
#                delete_normal_object_from_panel(file1.get_basename())
                return;
            else:
                delete_from_panel(file1.get_path())
            if os.path.exists(dekstopdir +"/" + file1.get_basename()):
                os.remove(dekstopdir +"/" + file1.get_basename())

curstate = os.listdir("/usr/share/applications")
gfile = Gio.File.new_for_path("/usr/share/applications")
monitor = gfile.monitor_directory(Gio.FileMonitorFlags.NONE, None)
monitor.connect("changed", directory_changed) 
 
ml = GLib.MainLoop()
ml.run()
